#!/usr/bin/python

from rep_tree_maker import *

if __name__ == "__main__":
    tm = Tree_Maker()
    i = 0
    r = random.Random(6)
    while True:
        num_nodes = 5
        tree = tm.generate(1 << 16, num_nodes, 0.0, r)
        tree.nodes = [ 4 for n in tree.nodes ]
        max_spm_size = sum(tree.nodes)
        spm_size = max(tree.nodes)
        while spm_size < max_spm_size:
            fname = "lukes1.cs"
            out = []
            for soln_type in "PC":
                tree.write_csearch(file(fname, "wt"), spm_size, soln_type)
                rc = os.system("./csearch %s L" % fname)
                assert rc == 0
                (partition, spm_size, mode) = tree.read_csearch(
                        file(fname, "rt"))
                value = tree.get_value(partition, "P")
                out.append((partition, value))

            (partition1, value1) = out[0]
            (partition2, value2) = out[1]

            G1R1 = tree.get_value(partition1, "P")
            G2R1 = tree.get_value(partition1, "C")
            G1R2 = tree.get_value(partition2, "P")
            G2R2 = tree.get_value(partition2, "C")

            assert G1R1 <= G1R2
            assert G2R2 <= G2R1

            if (G1R1 != G1R2) and (G2R2 != G2R1):
                print ''
                print '***' * 10
                print 'FOUND'
                print 'R1 = %s' % partition1
                print 'R2 = %s' % partition2
                print 'Gamma_1(R1) = %u' % G1R1
                print 'Gamma_2(R1) = %u' % G2R1
                print 'Gamma_1(R2) = %u' % G1R2
                print 'Gamma_2(R2) = %u' % G2R2
                print ''
                file("lukes1.gv", "wt").write(tree.graphviz([]))
                sys.exit(0)

            spm_size *= 2

