#!/usr/bin/python

from rep_tree_maker import *

if __name__ == "__main__":
    tm = Tree_Maker()
    i = 0
    best_disco = 0
    r = random.Random(19)
    while True:
        num_nodes = r.randint(10, 14)
        tree = tm.generate(1 << 16, num_nodes, 0.0, r)
        tree.nodes = [ 4 for n in tree.nodes ]
        max_spm_size = sum(tree.nodes)
        spm_size = max(tree.nodes)
        while spm_size < max_spm_size:
            fname = "lukes2.cs"
            out = []
            for soln_type in "EC":
                tree.write_csearch(file(fname, "wt"), spm_size, soln_type)
                rc = os.system("./csearch %s L" % fname)
                assert rc == 0
                (partition, spm_size, mode) = tree.read_csearch(
                        file(fname, "rt"))
                value = tree.get_value(partition, "C")
                out.append((partition, value))

            (partition1, value1) = out[0]
            (partition2, value2) = out[1]

            disco = abs(value1 - value2)
            if disco > best_disco:
                best_disco = disco
                print '****', disco
                fd = file("lukes2.ce", "wt")
                fd.write('\nR1 = %s' % partition1)
                fd.write('\nR2 = %s' % partition2)
                fd.write('\nGamma_2(R1) = %u' % value1)
                fd.write('\nGamma_2(R2) = %u' % value2)
                fd.write('\n')
                fd.close()
                file("lukes2.gv", "wt").write(tree.graphviz(partition1))
                file("lukes2.dat", "wt").write(tree.dump())
                tree.write_csearch(file("lukes2.sav", "wt"), 
                            spm_size, "E")

            spm_size *= 2

