#!/usr/bin/python

import rep_tree_maker, random, os, sys

import csp

if __name__ == "__main__":
    tm = rep_tree_maker.Tree_Maker()
    if len(sys.argv) > 1:
        r = random.Random(int(sys.argv[1]))
    else:
        r = random.Random(1)
    mode = "W"
    counter = 0

    while True:
        back_edge_prob = 0
        if mode == "W":
            back_edge_prob = 0.1

        num_nodes = r.randint(8, 20)
        tree = tm.generate(1 << 16, num_nodes, back_edge_prob, r)
        if r.randint(1, 4) == 2:
            tree.nodes = [ 4 for n in tree.nodes ]

        tree.fixed_cost = r.randint(0, 10)

        name = "tmp/tester-%u" % os.getpid()
        fname = "%s.cs" % name
        max_spm_size = sum(tree.nodes)
        spm_size = max(tree.nodes)
        while spm_size < max_spm_size:
            counter += 1
            out = []
            for solver_type in "XL":
                tree.write_csearch(file(fname, "wt"), spm_size, mode)
                #rc = os.system("./csearch %s %s >%s.out" % (
                #            fname, solver_type, name))
                check_value = csp.do_csearch(fname, solver_type)
                assert check_value != 0
                (partition, spm_size, mode) = tree.read_csearch(
                                    file(fname, "rt"))

                tree.fixup(partition)
                value = tree.get_value(partition, mode)
                out.append((partition, value, solver_type))

                #fd = file("%s.out" % name, "rt")
                #fields = fd.readline().split()
                #fd.close()
                #check_value = int(fields[0])
                if check_value != value:
                    print 'rep_tree_maker.py got a different value for'
                    print partition
                    print 'rep_tree_maker.py value = %u' % (value)
                    print 'csearch.c value = %u' % (check_value)
                    print 'mode = %s   solver_type = %s' % (mode, solver_type)

                    file("%s.tree" % name, "wt").write(tree.dump())
                    file("%s.gv" % name, "wt").write(tree.graphviz(partition))
                    sys.exit(1)

            (partition1, value1, _) = out[0]
            (partition2, value2, _) = out[1]

            if (value1 != value2) or (value1 == 0):
                print 'failed comparison between exhaustive and Lukes/ELA'
                print ''

                for (partition, value, solver_type) in out:
                    print 'solver %s: value %u' % (solver_type, value)
                    print partition
                    print ''

                file("%s.tree" % name, "wt").write(tree.dump())
                file("%s.gv" % name, "wt").write(tree.graphviz(partition1))
                sys.exit(1)

            print '%08u %s %8.3e %3u %3u' % (
                    counter, mode, value,
                    len(tree.nodes), len(tree.back_edges))
            
            spm_size *= 2

